###############################################################################
#
# <p>Livedoor Weather ŷͽɽ</p>
# <pre>
#   {{livedoorweather 63,today}}
# </pre>
# <p>
# citynumber,[today|tomorrow|dayaftertomorrow]
# </p>
#
###############################################################################
package plugin::livedoorweather::LivedoorWeather;
use LWP::UserAgent;
use XML::Simple;
use Unicode::RecursiveDowngrade;
use Encode qw/from_to/;

#==============================================================================
# 󥹥ȥ饯
#==============================================================================
sub new {
  my $class = shift;
  my $self = {};
  return bless $self,$class;
}
#==============================================================================
# ѥ饰ե᥽å
#==============================================================================
sub paragraph {
  my $self = shift;
  my $wiki = shift;
  my $city = shift;
  my $day = shift;

  my $xml;

  unless($day){
    $day = 'today';
  }

  my $UserAgent = 'FSWikiPlugin/0.1';

  my $request_url = 'http://weather.livedoor.com/forecast/webservice/rest/v1';
  $request_url .= '?city='.$city.'&day='.$day;

  my $ua = LWP::UserAgent->new;
  $ua->timeout(10);
  $ua->agent($UserAgent);
  my $res = $ua->get($request_url);
  if($res->is_success){
    my $rd = Unicode::RecursiveDowngrade->new;
    $xml = $rd->downgrade(XMLin($res->content,SuppressEmpty => undef));
  }

  my $buf = "<div class=\"livedoorweather\"><table>";
  
  if($xml){
    my $image_url = $xml->{image}->{url};
    my $title = $xml->{title};
    $title =~ s/^.*- //;
    my $link = $xml->{link};
    my $telop = $xml->{telop};
    my $pref = $xml->{location}->{pref};
    my $city = $xml->{location}->{city};
    my $max = $xml->{temperature}->{max}->{celsius};
    $max = '--' unless($max);
    my $min = $xml->{temperature}->{min}->{celsius};
    $min = '--' unless($min);
    
    $buf .= "<tr><td><a href='$link' title ='$telop'>$pref $city</a></td></tr>";
    $buf .= "<tr><td>$title</td></tr>";
    $buf .= "<tr><td><a href='$link' title='$telop'><img src='$image_url'></a></td></tr>";
#    $buf .= "<tr><td><font color=\"red\">$max</font>/<font color=\"blue\">$min</font></td></tr>";
  }else{
    return Util::paragraph_error('顼');
  }

  $buf .= "</table></div>";

  from_to($buf,"utf8","euc-jp");  

  return $buf;
}

1;
